open Types
open Parametres
open Primitive

class disc (col:couleur) (posVal:point) (wire:draw)(radiusVal:float) (slicesVal:int) =
  object (self)
    inherit primitive col wire as super

    (*Members*)
    val mutable pos = posVal
    val mutable radius = radiusVal
    val mutable slices = slicesVal

    (*Methods*)
    (*-------*)

    (*Setter & getter*)
    method setPos newPos = pos <- newPos
    method getPos = pos
    
    method setRadius newRadius = radius <- newRadius
    method getRadius = radius

    method setSlices newSlices = slices <- newSlices
    method getSlices = slices
    
    method drawSelf () = self#setGLColor;
                       let cosSlice = Array.make slices 0.0
		       and sinSlice = Array.make slices 0.0
                       in
			 for j =  0  to (slices - 1)
			 do
			   let phi = (pi2 *. (float_of_int j)) /. (float_of_int slices)
			   in
			     cosSlice.(j) <- cos phi;
			     sinSlice.(j) <- sin phi
			 done;
      
			 (* Ple Nord *)
			 GlDraw.begins `triangle_fan;
			 GlDraw.normal3 (0.0, 1.0, 0.0);
			 GlDraw.vertex3 (0.0, 0.0, 0.0);
			 GlDraw.vertex3 (radius, 0.0, 0.0);
			 for j = (slices - 1) downto 0
			 do
			   GlDraw.vertex3 (radius *. cosSlice.(j), 0.0, radius *. sinSlice.(j))
			 done;
			 GlDraw.ends ();
			 
			 (* Ple Sud *)
			 GlDraw.begins `triangle_fan;
			 GlDraw.normal3 (0.0, -1.0, 0.0);
			 GlDraw.vertex3 (0.0, 0.0, 0.0);
			 for j = 0 to (slices - 1)
			 do
			   GlDraw.vertex3 (radius *. cosSlice.(j), 0.0, radius *. sinSlice.(j))
			 done;
			 GlDraw.vertex3 (radius, 0.0, 0.0);
			 GlDraw.ends ()
			   
    method getBoundingBox () = (-. radius, 0.0, -. radius, radius, 0.0, radius)

  end
