(*****************************************************)
(*                                                   *)
(* La classe imo_apropos permet d'afficher une bote *)
(* de dialogue nonant les crateur du programme.   *)
(*                                                   *)
(*****************************************************)



class imo_apropos () =

  let window = GWindow.window ~wm_name:"A propos ..."
			      ~title:"Imoview - A propos ..."
			      ~position:`CENTER
			      ~kind:`DIALOG
			      ~modal:false
			      ~allow_shrink:false
			      ~allow_grow:false
			      ~auto_shrink:false
			      ()
  in

  let table = GPack.table ~rows:2
			  ~columns:2
			  ~row_spacings:0
			  ~col_spacings:0
			  ~border_width:10
			  ~homogeneous:false
			  ~packing:window#add
			  ()
  in

  (* Affiche le logo MGS *)
  let logo = GMisc.pixmap (GDraw.pixmap_from_xpm_d ~data:Icones.mgs ~window ())
			  ~packing:(table#attach ~left:0
						 ~top:0
						 ~right:1
						 ~bottom:2
						 ~xpadding:0
						 ~ypadding:0
						 ~expand:`NONE
						 ~shrink:`NONE
						 ~fill:`BOTH
				   )
			  ~xalign:0.5
			  ~yalign:0.5
			  ~xpad:0
			  ~ypad:0
			  ()
  in

  let hbox = GPack.hbox ~spacing:10
			~homogeneous:false
			~packing:(table#attach ~left:1
					       ~top:0
					       ~right:2
					       ~bottom:1
					       ~xpadding:0
					       ~ypadding:0
					       ~expand:`NONE
					       ~shrink:`NONE
					       ~fill:`NONE
				 )
			()
  in

  let _ = GMisc.label ~text:"Auteurs :"
		      ~packing:(hbox#pack ~padding:0
					  ~fill:false
					  ~expand:false
			       )
		      ~justify:`LEFT
		      ~xalign:0.0 
		      ~yalign:0.0
		      ~xpad:0
		      ~ypad:0
		      ~line_wrap:false
		      ()
  in

  let _ = GMisc.label ~text:"Benoit 'Ben' CALVEZ\nFabien 'SuperBT' THONNERIEUX"
		      ~packing:(hbox#pack ~padding:0
					  ~fill:false
					  ~expand:false
			       )
		      ~justify:`LEFT
		      ~xalign:0.0 
		      ~yalign:0.0
		      ~xpad:0
		      ~ypad:0
		      ~line_wrap:false
		      ()
  in

  let bottom = GPack.button_box `HORIZONTAL
				~spacing:30
				~child_width:85
				~child_height:24
				~layout:`SPREAD
				~packing:(table#attach ~left:1
						       ~top:1
						       ~right:2
						       ~bottom:2
						       ~xpadding:0
						       ~ypadding:0
						       ~expand:`BOTH
						       ~shrink:`NONE
						       ~fill:`BOTH
					 )
				()
  in

  let retour = GButton.button ~packing:(bottom#pack )
			      ~label: "Retour"
			      ()
  in

  let _ = retour#grab_default ()
  in


object(self)


  method window        = window
  method on_quitter () = window#destroy ()
  method on_window_remove (widget:GObj.widget) = self#on_quitter ()


initializer


  (* ESC -> ferme la fentre *)
  let _ = window#event#connect#key_press ~callback:(fun (event: GdkEvent.Key.t) -> begin
										     if (GdkEvent.Key.keyval event) = GdkKeysyms._Escape
										     then
										       begin
											 self#on_quitter();
											 true
										       end
										     else false
										   end
						   )
  in

  (* Bouton retour -> ferme la fentre *)
  let _ = retour#connect#clicked ~callback:self#on_quitter
  in

  let _ = window#connect#remove  ~callback:self#on_window_remove
  in

    () 

end
