(***************************************************************************)
(*                                                                         *)
(* Le fichier parametres.ml contient toutes sortes de variables "globlaes" *)
(* utilises dans plusieurs fichiers diffrents.                           *)
(*                                                                         *)
(***************************************************************************)



open Types
open File


(**************)
(* Constantes *)
(**************)


(* Pi *)
let pi = 3.1415926535897932384626433832795029

(*  2 Pi  *)
let pi2  = 6.2831853071795864769252867665590058

(* Pi / 2 *)
let pi_2 = 1.5707963267948966192313216916397514

(* Sin(Pi/8) *)
let sin_pi_8 = 0.3826834323651

(* racine de 2 *)
let sqrt2 = 1.4142135623730950488016887242096981

(*       Racine de 3        *)
let sqrt3 = 1.732050807568877

(*       Racine de 6        *)
let sqrt6 = 2.449489742783178

(* Origin *)
let ori = new point 0.0 0.0 0.0

let getOri () = new point 0.0 0.0 0.0

(*********************)
(* Fenetre principal *)
(*********************)

(*let window = new Guimain.imo_window ()*)



(***********************************)
(* Donnes de l'analyse syntaxique *)
(***********************************)

(* Nom du fichier source *)
let file_name = ref ""

(* Nom du fichier source *)
let entree = ref File


(* Numro de ligne de la lecture du fichier *)
let line = ref 1


(**********)
(* Dessin *)
(**********)



(****************************)
(* Slection des Containers *)
(****************************)


(* Container slectionn *)
let select = (ref None:drawable option ref)


(* Etat du clignotement (taux de transparence) *)
let clignote_rate = ref 1.0


(* ~drive de clignote_rate *)
let clignote_sign = ref 0.1



(*********************************)
(* Etat des boutons de la souris *)
(*********************************)


(* Bouton gauche  de la souris *)
let   leftButton = new mouseButton


(* Bouton central de la souris *)
let middleButton = new mouseButton


(* Bouton droit   de la souris *)
let  rightButton = new mouseButton



(*******************)
(* Capture d'cran *)
(*******************)


(* indice du screenshot *)
let shot = ref 0


(* Indique si une capture dans un format vectoriel est en cours *)
let isVectoring = ref false




(*******************)
(* Var pour guigtk *)
(*******************)

  (* swap-buffers de l'aire OpenGL *)
  let swapbuffers = ref (fun () -> ())

  (* GTKGL area *)
  let area = ref (None:GlGtk.area option)

  (* taille de l'aire OpenGL *)
  let width = ref 500.0
  let height = ref 400.0

  let ecrireStatut = ref (fun (s:string)->())

(*  let idle = ref(GMain.Timeout.add ~ms:100000 ~callback:(fun ()->true))*)

  let encodeLine = ref "transcode -i %list -x imlist,null -g %wx%h -y xvid,null -f %fps -o %nom -H 0"

(*******************)
(* Var pour Thread *)
(*******************)

(*When using threads to avoid paralell call of function view*)
let drawMutex = Mutex.create ();;

(*Avoid double call of load at a time*)
let loadMutex = Mutex.create ();;

(*Only one command at a time*)
let commandMutex = Mutex.create ();;

(********************)
(* Var pour Loading *)
(********************)

(*Execute all commands instantly after they have been read by the parser*)
let instantLoad = ref false

(*Minimal size of buffer to start display if instant loading is active*)
let minBufSize = ref 10

let isLoading = ref false

(*Load file from stdin*)
let piped = ref false
