open Types
open Parametres
open Primitive
open Viewport
open Boundingbox

class polyline (col:couleur) (wire:draw)(pointL:point list ref) =
  object(self)
    inherit primitive col wire as super
    
    (*Members*)
    val mutable pointList = pointL

    (*Methods*)
    method drawSelf () = let sbt shape = GlDraw.begins shape;
			                 (*List.iter (function pt -> GlDraw.vertex3 (pt#getX, pt#getY, -. pt#getZ)) !pointList;*)
			                 List.iter (function pt -> GlDraw.vertex3 (pt#getX, pt#getY, pt#getZ)) !pointList;
					 GlDraw.ends ()
                         in
                           (*Set draw color*)
                           super#setGLColor;
                           (* Les traits n'ont pas de normale -> on dsactive la lumire *)
                           Gl.disable `lighting;
			   if view#getPolygonMode = `point
			   then
			     sbt `points
			   else
			     begin
			       if !Parametres.isVectoring
			       then
				 begin
				   Vectoriel.psLineWidth 1.5;
				   sbt `line_strip;
				   Vectoriel.psLineWidth 1.0
				 end
			       else
				 begin
				   GlDraw.line_width 1.5;
				   sbt `line_strip;
				   GlDraw.line_width 1.0
				 end
				 
			     end;
			   if view#getLighting
			   then
			     Gl.enable `lighting
			       
    method getPoints = ! pointList
    method setPoints newPointList = pointList <- ref newPointList;


    (********************************************************)
    (* Calcule le BoundingBox d'une liste de points         *)
    (********************************************************)
    (* Type : point list ->                                 *)
    (*        float * float * float * float * float * float *)
    (********************************************************)
    method boundingPolyline = match !pointList
                              with
				| []     -> (0.0, 0.0, 0.0, 0.0, 0.0, 0.0)
				| hd::tl -> let rec extremPolyline lst bounding = match lst
				                                                  with
										    | []     -> bounding
										    | hd::tl -> let newBound = (* Compute bounding only if point is defined *)
											                       if (hd#isDefault) then
														 bounding
										                               else
											                         bounding_fusion bounding (hd#getX,
															                   hd#getY,
																	   hd#getZ,
																	   hd#getX,
																	   hd#getY,
																	   hd#getZ)
										                in
												  extremPolyline tl newBound
				            in
				              extremPolyline tl (hd#getX, hd#getY, hd#getZ, hd#getX, hd#getY, hd#getZ) 

    method getBoundingBox () = self#boundingPolyline
  end
